JavaRef subclass:#JavaFieldref
	instanceVariableNames:'offset'
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Reader-Support'
!


!JavaFieldref methodsFor:'printing & storing'!

displayString
    ^ 'JavaFieldRef (' , class fullName , ' ' 
                        , '''' , nameandType name , '''' , nameandType signature , ')'
! !

!JavaFieldref methodsFor:'resolving'!

offset
    |nm sig mthd|

    offset notNil ifTrue:[^ offset].

    (class isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
        class := class resolve
    ].
    (class isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
        self halt.
    ].

    nm := nameandType name asSymbol.
    sig := nameandType signature.

    offset := class instVarOffsetOf:nm.
    ^ offset.
!

staticOffset
    |nm sig mthd|

    offset notNil ifTrue:[^ offset].

    (class isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
        class := class resolve
    ].
    (class isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
        self halt.
    ].

    nm := nameandType name asSymbol.
    sig := nameandType signature.

    offset := class class instVarOffsetOf:nm.
    ^ offset.
! !

!JavaFieldref class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaFieldref.st,v 1.7 1996/05/03 18:55:34 cg Exp $'
! !
